#!/usr/bin/env python
# -*- coding:utf-8 -*-

# ##############################################################################
#     Base code from where the autogenerated code inherits
#
#     Copyright (C) 2021 Alba Synchrotron/CELLS, Cerdanyola Spain
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see [http://www.gnu.org/licenses/].
# ##############################################################################

"""
This code contains the class that knows about the communications with the
specific card used to control the DLLRF.
"""

__all__ = ["DLLRFBase", "DLLRFBaseClass"]

__author__ = 'sblanch'

__docformat__ = 'restructuredtext'


# dependency imports
from datetime import datetime
from numpy import array, append
import pprint
import re
import tango
from threading import Event, Thread
from time import sleep
import traceback

# local imports
from .alba import (
    AlbaStruck, CardReader, ProcessStatistics, AttributeInterpreter,
    build_value_timestamp_quality, fire_events,
    fpga_initialization_procedure, get_none_value_by_type,
    replace_attributes)
from .attribute import Access, Attribute, DataType
from .constants import version


class DLLRFBase(tango.Device_5Impl):
    def __init__(self, cl, name):
        tango.Device_5Impl.__init__(self, cl, name)
        self.debug_stream("In __init__()")
        self._globals = globals()
        self._locals = {'self': self}
        self.card = None
        self.reader = None
        self.interpreter = None
        self.statistics = None
        self._attributes_dict = {}
        self._important_status_lines = []
        self._internal_thread = None
        self._start_thread = None
        self._start_procedure_logs = None
        self._internal_polling = None
        self._join_event = None
        DLLRFBase.init_device(self)

    def delete_device(self):
        self.debug_stream("In delete_device()")
        self._join_event.set()
        self._internal_thread.join(timeout=self._internal_polling)
        if self._start_thread is not None and \
                isinstance(self._start_thread, Thread) and \
                self._start_thread.is_alive():
            self._start_thread.join()

    def init_device(self):
        self.set_change_event('State', True, False)
        self.set_change_event('Status', True, False)
        self._change_state_status(tango.DevState.INIT)
        self.debug_stream("In init_device()")
        self.get_device_properties(self.get_device_class())
        if self.BoardModel.lower() == 'struck' and AlbaStruck is not None:
            try:
                try:
                    self.card = AlbaStruck(
                        self.BoardId, write_offset=self.WriteOffset)
                    self.reader = CardReader(self.card)
                    self.interpreter = AttributeInterpreter(
                        self, self._attributes_dict)
                    self.statistics = ProcessStatistics()
                    self._join_event = Event()
                    self._join_event.clear()
                    self._internal_polling = 1.0  # s
                    self._internal_thread = Thread(
                        target=self._internal_procedures, daemon=True)
                    self._internal_thread.start()
                except Exception as exc:
                    msg = f"Cannot create a card object: {exc}"
                    self.error_stream(msg)
                    self._change_state_status(
                        tango.DevState.FAULT, status_line=msg,
                        is_an_important_line=True, clean_important_lines=True)
                else:
                    self._change_state_status(
                        tango.DevState.ON, clean_important_lines=True)
            except Exception as exc:
                # FIXME be more specific to when card not present
                # TODO: report in the status and left it at fault state.
                msg = f"unexpected error in the initialization: {exc}"
                self._change_state_status(
                    tango.DevState.FAULT, status_line=msg,
                    is_an_important_line=True)
        else:
            msg = f"Card model {self.BoardModel!r} unsupported"
            self._change_state_status(
                tango.DevState.FAULT, status_line=msg,
                is_an_important_line=True, clean_important_lines=True)

# ------------------------------------------------------------------------------
#    Device attributes
# ------------------------------------------------------------------------------
    def read_attr_hardware(self, data):
        # self.debug_stream("In read_attr_hardware()")
        return self.get_state() in [tango.DevState.ON,
                                    tango.DevState.STANDBY,
                                    tango.DevState.RUNNING]

    def read_Version_DeviceServer(self, attr):
        self.debug_stream("In read_Version_DeviceServer()")
        attr.set_value(version)

    def read_internal_polling(self, attr):
        attr.set_value(self._internal_polling)

    def write_internal_polling(self, attr):
        new_value = float(attr.get_write_value())
        if new_value <= 0:
            raise ValueError("internal polling must be strictly positive")
        self._internal_polling = new_value

    def read_time_arrays_max_length(self, attr):
        attr.set_value(self.statistics.time_arrays_max_length)

    def write_time_arrays_max_length(self, attr):
        self.statistics.time_arrays_max_length = float(attr.get_write_value())

    def read_internal_procedure_times(self, attr):
        attr.set_value(self.statistics.internal_procedure_times)

    def read_internal_procedure_times_min(self, attr):
        if len(self.statistics.internal_procedure_times) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.internal_procedure_times.min())

    def read_internal_procedure_times_mean(self, attr):
        if len(self.statistics.internal_procedure_times) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.internal_procedure_times.mean())

    def read_internal_procedure_times_std(self, attr):
        if len(self.statistics.internal_procedure_times) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.internal_procedure_times.std())

    def read_internal_procedure_times_max(self, attr):
        if len(self.statistics.internal_procedure_times) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.internal_procedure_times.max())

    def read_read_registers_time(self, attr):
        attr.set_value(self.statistics.read_registers_time)

    def read_read_registers_time_min(self, attr):
        if len(self.statistics.read_registers_time) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.read_registers_time.min())

    def read_read_registers_time_mean(self, attr):
        if len(self.statistics.read_registers_time) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.read_registers_time.mean())

    def read_read_registers_time_std(self, attr):
        if len(self.statistics.read_registers_time) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.read_registers_time.std())

    def read_read_registers_time_max(self, attr):
        if len(self.statistics.read_registers_time) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.read_registers_time.max())

    def read_process_registers_time(self, attr):
        attr.set_value(self.statistics.process_registers_time)

    def read_process_registers_time_min(self, attr):
        if len(self.statistics.process_registers_time) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.process_registers_time.min())

    def read_process_registers_time_mean(self, attr):
        if len(self.statistics.process_registers_time) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.process_registers_time.mean())

    def read_process_registers_time_std(self, attr):
        if len(self.statistics.process_registers_time) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.process_registers_time.std())

    def read_process_registers_time_max(self, attr):
        if len(self.statistics.process_registers_time) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.process_registers_time.max())

    def read_internal_formulas_time(self, attr):
        attr.set_value(self.statistics.internal_formulas_time)

    def read_internal_formulas_time_min(self, attr):
        if len(self.statistics.internal_formulas_time) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.internal_formulas_time.min())

    def read_internal_formulas_time_mean(self, attr):
        if len(self.statistics.internal_formulas_time) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.internal_formulas_time.mean())

    def read_internal_formulas_time_std(self, attr):
        if len(self.statistics.internal_formulas_time) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.internal_formulas_time.std())

    def read_internal_formulas_time_max(self, attr):
        if len(self.statistics.internal_formulas_time) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.internal_formulas_time.max())

    def read_events_emitted(self, attr):
        attr.set_value(self.statistics.events_emitted)

    def read_events_emitted_min(self, attr):
        if len(self.statistics.events_emitted) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.events_emitted.min())

    def read_events_emitted_mean(self, attr):
        if len(self.statistics.events_emitted) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.events_emitted.mean())

    def read_events_emitted_std(self, attr):
        if len(self.statistics.events_emitted) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.events_emitted.std())

    def read_events_emitted_max(self, attr):
        if len(self.statistics.events_emitted) == 0:
            attr.set_value_date_quality(
                0, float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID)
        else:
            attr.set_value(self.statistics.events_emitted.max())

    def read_start_procedure_output(self, attr):
        if self._start_procedure_logs is None:
            attr.set_value_date_quality(
                [""], float(datetime.now().strftime('%s.%f')),
                tango.AttrQuality.ATTR_INVALID, 1)
        else:
            attr.set_value(self._start_procedure_logs)


# ------------------------------------------------------------------------------
#    Device commands
# ------------------------------------------------------------------------------
    # TODO: Start, Stop
    # TODO: expert Read, Write

    def Exec(self, argin):
        """
Evaluate python code inside the device server.

This command can be very helpful and dangerous.

        :param argin:
        :type: PyTango.DevString
        :return:
        :rtype: PyTango.DevString """
        self.debug_stream("In Exec()")
        argout = ''
        # ----- PROTECTED REGION ID(Skippy.Exec) ENABLED START -----#
        self.debug_stream(f"In Exec() argin {argin!r}")
        if argin.count("=") == 0:  # a query, not assignment
            try:
                argout = eval(argin, self._globals, self._locals)
            except SyntaxError as expression_exception:
                self.warn_stream(f"Interpreting as expression Exception: "
                                 f"{expression_exception}")
                argout = traceback.format_exc()
        else:  # in case the argin contains an assignment
            try:
                exec(argin, self._globals, self._locals)
                argout = self._locals.get("y")
            except Exception as statement_exception:
                self.warn_stream(f"Interpreting as statement Exception: "
                                 f"{statement_exception}")
                argout = traceback.format_exc()
        if isinstance(argout, str):
            pass  # return argout
        elif isinstance(argout, BaseException):
            argout = f"{argout.__class__.__name__}\n{argout!s}"
        else:
            try:
                argout = pprint.pformat(argout)
            except Exception:
                argout = str(argout)
        try:
            self.debug_stream(f"argout {argout!r}")
        except Exception as exception:
            self.error_stream(f"In Exec command: couldn't format string "
                              f"the argout: {exception}")
        return argout

    def Start(self):
        self.info_stream("Start() called")
        _current_state = self.get_state()
        if _current_state not in [tango.DevState.ON]:
            self.warn_stream(f"Start() called in {_current_state}, ignoring it")
            return False
        if self._start_thread is not None and \
                isinstance(self._start_thread, Thread) and \
                self._start_thread.is_alive():
            self.warn_stream(f"Start() called with a thread already working")
            return False
        try:
            self._change_state_status(state=tango.DevState.STANDBY,
                                      status_line="Start procedures launched",
                                      is_an_important_line=True,
                                      clean_important_lines=True)
            self._start_thread = Thread(target=self._start_procedures,
                                        daemon=True)
            self._start_procedure_logs = None
            self._start_thread.start()
        except Exception as _exception:
            self.error_stream(f"Start failed due to: {_exception}")
            self._start_thread = None
            self._change_state_status(state=tango.DevState.ON,
                                      status_line="Start procedures failed",
                                      clean_important_lines=True)
            return False
        self.debug_stream("Start() completed")
        return True

    def Stop(self):
        current_state = self.get_state()
        if current_state not in [tango.DevState.RUNNING]:
            self.warn_stream(f"Stop() called in {current_state}, ignoring it")
            return False
        # TODO: it hasn't been specified if there is something to undo
        self.info_stream("Stop() called")
        self._change_state_status(state=tango.DevState.ON)
        self.debug_stream("Stop() completed")
        return True

# ------------------------------------------------------------------------------
#    internal methods
# ------------------------------------------------------------------------------

    def _change_state_status(self, state=None, status_line=None,
                             is_an_important_line=False,
                             clean_important_lines=False):
        """
Common method to do all the necessary things to manage the tango state and
status.
:param state: New state to be set if not None
:param status_line: New status line to be included to the default one
:param is_an_important_line: store the status_line to be remembered on future
                             calls that append other messages
:param clean_important_lines: indication to clean previous messages tagged as
                              important
:return: None
        """
        new_state = self.__process_new_state(state)
        new_status = self.__process_new_status(
            status_line, is_an_important_line, clean_important_lines)
        if new_state is not None:
            self.push_change_event('State', new_state)
            self.debug_stream(f"State change to {new_state}")
        if new_status is not None:
            self.push_change_event('Status', new_status)
            self.debug_stream(f"Status change to {new_status!r}")

    def __process_new_state(self, state):
        """
Internal method to include some checks before change the state.

:param state: expected to be a tango state
:return: the state set or None if it is not possible
        """
        if state is not None and state != self.get_state() and \
                str(state) in [element for element in dir(tango.DevState)
                               if element.isupper()]:
            self.set_state(state)
            return state

    def __process_new_status(self, status_line, is_an_important_line,
                             clean_important_lines):
        """
Internal method to generate a new status, starting with the line that reports
the state, followed by the previous messages considered important to end with
the new status line to insert. It also manages the reset of the list of
important messages.

:param status_line: New status line to be included to the default one
:param is_an_important_line: store the status_line to be remembered on future
                             calls that append other messages
:param clean_important_lines: indication to clean previous messages tagged as
                              important
:return:
        """
        new_status_as_list = [f"The device is in {self.get_state()} state.\n"]
        if clean_important_lines is True:
            self._important_status_lines = []
        if len(self._important_status_lines) > 0:
            new_status_as_list += self._important_status_lines
        if hasattr(status_line, '__len__') and len(status_line) > 0:
            if not status_line.endswith('\n'):
                status_line = f"{status_line}\n"
            if is_an_important_line:
                self._important_status_lines.append(status_line)
            new_status_as_list.append(status_line)
        new_status = ''.join(new_status_as_list)
        self.set_status(new_status)
        return new_status

    def create_attribute(self, address, attribute, access, att_type, att_dtype,
                         unit=None, min_value=None, max_value=None,
                         w_formula=[], r_formula=[]):
        """
Builder method to create any of the supported types of attributes in this
control.

About the address. The fpga program has two write registers (consecutive) and
a readback one spaced a constant distance (default 0x200). So with the
information of the first write register all the other information can be
deduced.

:param address: numerical value of the first write register
:param attribute: string with the name
:param access: if it is RO or RW
:param att_type: if the attribute represents a settings/loops
                 register or one from diagnostics
:param att_dtype: type of the data to interpret the register
:param unit: (optional) information to be published in tango
:param min_value: (optional) lower limit
:param max_value: (optional) upper limit
:param w_formula: evaluable string
:param r_formula: evaluable string
:return:
        """
        self.set_change_event(attribute, True, False)
        try:
            new_attribute = Attribute(address, attribute, access, att_type,
                                      att_dtype, unit=unit, min_value=min_value,
                                      max_value=max_value, fwrite=w_formula,
                                      fread=r_formula)
        except Exception as exc:
            self.error_stream(f"Error crating {attribute}: {exc}")
            raise exc
        new_attribute.set_value(min_value)
        if attribute not in self._attributes_dict.keys():
            self._attributes_dict[attribute] = new_attribute
        else:
            already_existing_attribute_obj = self._attributes_dict[attribute]
            if address is not None:
                if already_existing_attribute_obj.address is not None:
                    err_msg = f"In create_attribute(): Duplicated attribute " \
                              f"{attribute}! It was defined for register " \
                              f"0x{already_existing_attribute_obj.address:X} " \
                              f"and now on 0x{address:X}."
                else:
                    err_msg = f"In create_attribute(): Duplicated attribute " \
                              f"{attribute}! It didn't have address and now " \
                              f"is trying to define it on 0x{address:X}"
            else:
                if already_existing_attribute_obj.address is not None:
                    err_msg = f"In create_attribute(): Duplicated attribute " \
                              f"{attribute}! It was defined for register " \
                              f"0x{already_existing_attribute_obj.address:X} " \
                              f"and now without address"
                else:
                    err_msg = f"In create_attribute(): Duplicated attribute " \
                              f"{attribute}!"
            self.error_stream(err_msg)

    def read_Attribute(self, attr, attribute):
        """
Main method to be use by any of the special attributes when there is a read
from tango.

:param attr: tango object of the attribute
:param attribute: string of the attribute name
:return:
        """
        # self.debug_stream(f"In read_Attribute(): {attribute}")
        try:
            attribute_obj = self._get_internal_attribute_obj(attribute)
        except KeyError as exc:
            self.error_stream(f"In read_Attribute(): {exc}")
            return
        value, timestamp, quality = build_value_timestamp_quality(
            attribute_obj)
        attr.set_value_date_quality(value, timestamp, quality)

    def write_Attribute(self, attr, attribute):
        """
Main method to be use by any of the special attributes when there is a write
from tango.

:param attr: tango object of the attribute
:param attribute: string of the attribute name
:return:
        """
        self.debug_stream(f"In write_Attribute(): {attribute}")
        # get internal structure information
        try:
            wattribute = self._get_internal_attribute_obj(attribute)
        except KeyError as exc:
            self.error_stream(f"In write_Attribute(): {exc}")
            return
        # get what the user has set as a write value
        WRITE_VALUE = self._get_attribute_write_value(attr)
        # work with formula information
        try:
            self._apply_write_formula(wattribute, WRITE_VALUE)
        except Exception as exception:
            self.error_stream(f"In write_Attribute(): {attribute} "
                              f"Error found {exception}")
            return
        fire_events(self, attribute, WRITE_VALUE)

    def is_Attribute_allowed(self, attr, attribute):
        """
Main method to be use by any of the special attributes before they would be read
to verify that the device allows to do that.

:param attr: tango attribute object
:param attribute: string with the name of the attribute
:return: boolean reporting if it is allowed or not
        """
        internal_attribute_obj = self._get_internal_attribute_obj(attribute)
        if self.get_state() == tango.DevState.FAULT:
            self.debug_stream(f"it is currently not allow to access "
                              f"{attribute} because the device is in FAULT")
            return False
        return True

    def _get_internal_attribute_obj(self, name):
        """
Given a name, check if it is one of the internal attributes

:param name: string
:return: internal attribute object
        """
        if name in self._attributes_dict.keys():
            return self._attributes_dict[name]
        raise KeyError(f"{name} not found in internal attributes")

    def _get_attribute_read_value(self, internal_attr_obj):
        """
Given an internal attribute object, check its records to know the read value.

If it's about an attribute with an address in the fpga, read it (the read only
registers are them selves, the read_write readback are separated by a known
distance). If it is an purely internal object, return what's stored there.

:param internal_attr_obj:
:return: read value stored in the internal object
        """
        address = internal_attr_obj.address
        if address is not None and address != "":
            if internal_attr_obj.access == Access.read_write:
                address += self.card.write_offset
            read_value = self.card.read_register(address)
            self.debug_stream(f"In _get_attribute_read_value():"
                              f"Attr={internal_attr_obj.name} "
                              f"Address=0x{address:X} "
                              f"READ_VALUE={read_value}")
            return read_value
        else:
            read_value = internal_attr_obj.value
            self.debug_stream(f"In _get_attribute_read_value():"
                              f"Attr={internal_attr_obj.name} "
                              f"READ_VALUE={read_value}")
            return read_value

    @staticmethod
    def _get_attribute_write_value(tango_attr_obj):
        """
Given a tango object, get what has be set as write value.

:param tango_attr_obj:
:return: value received via tango write operation
        """
        WRITE_VALUE = tango_attr_obj.get_write_value()
        tango_attr_obj.set_write_value(WRITE_VALUE)
        return WRITE_VALUE

    def _apply_write_formula(self, internal_attr_obj, WRITE_VALUE):
        """
Given an internal attribute representation (agnostic if it represents an fpga
register or a purely internal thing) and a newer value to assign to it, check
if there is a transformation as a write formula to evaluate.

If there is a formula or formulas, evaluate them and return the result. It there
is no formula to applye transparent and return the incoming value.

:param internal_attr_obj: internal representation of an attribute
:param WRITE_VALUE: value received to be written
:return: the conversion, if there is such thing, to what has to be written to
         the fpga based on the input write value.
        """
        # FIXME: this method is still to long to be read in one screen
        formula = internal_attr_obj.fwrite
        # this supports a list of formulas to be applied in order
        # by the way, the read_formula doesn't support that
        if len(formula) > 1:
            for subformula in formula:
                subformula = replace_attributes(
                    subformula, self._attributes_dict)
                if "=" in subformula:
                    subformula_fields = subformula.split("=")
                    for attribute_name in self._attributes_dict.keys():
                        if subformula_fields[0] == (
                                f"self._attributes_dict"
                                f"['{attribute_name}'].value"):
                            new_formula = subformula_fields[1]
                            self.debug_stream(
                                f"In _apply_write_formula(): "
                                f"Attribute={attribute_name} "
                                f"Formula={new_formula}")
                            write_data = int(eval(new_formula))
                            self._do_write(
                                self._attributes_dict[attribute_name],
                                write_data)
                            fire_events(self, attribute_name,
                                        WRITE_VALUE)
                else:  # Apply direct formula to an attribute
                    self.debug_stream(f"In _apply_write_formula(): "
                                      f"Attribute={internal_attr_obj.name} "
                                      f"Formula={subformula}")
                    write_data = int(eval(subformula, locals()))
                    self._do_write(internal_attr_obj, write_data)
        elif formula[0] != "":
            # There is only a write formula set for this attribute.
            # Direct write to the address
            formula = replace_attributes(formula[0], self._attributes_dict)
            self.debug_stream(f"In write_Attribute(): "
                              f"Attribute={internal_attr_obj.name} "
                              f"Formula={formula}")
            write_data = int(eval(formula))
            self._do_write(internal_attr_obj, write_data)
        else:
            # There is no write formula set for this attribute.
            # Direct write to the address
            write_data = int(WRITE_VALUE)
            self._do_write(internal_attr_obj, write_data)

#     def _store_read_attribute(self, tango_attr_obj, internal_attr_obj, value):
#         """
# When there is a read value to be stored, this has to be stored in tango as well
# as in the internal attribute object.
#
# :param tango_attr_obj: tango attribute
# :param internal_attr_obj: internal representation of an attribute
# :param value: value read to
# :return:
#         """
#         value, timestamp, quality = build_value_timestamp_quality(
#             internal_attr_obj)
#         tango_attr_obj.set_value_date_quality(value, timestamp, quality)
#         internal_attr_obj.set_value(value)

    def _do_write(self, internal_attr_obj, value):
        """
Abstracts the difference between when the write has to be applied to the fpga
because the internal attribute represents a register there, to when this is a
pure internal object.

:param internal_attr_obj: internal representation of an attribute
:param value: value to be written to the fpga
:return: None
        """
        address = internal_attr_obj.address
        if address is not None and address != "":
            write_1 = address + self.card.write_offset
            write_2 = write_1 + 1
            self.debug_stream(f"In _do_write(): Write {value} to "
                              f"{internal_attr_obj.name} read register "
                              f"0x{address:X} "
                              f"(write on 0x{write_1:X} and 0x{write_2:X})")
            self.card.write_register(address, int(value))
        else:
            self.debug_stream(f"In _do_write(): Write {value} to "
                              f"{internal_attr_obj.name}")
            internal_attr_obj.value = value

    def _start_procedures(self):
        self.info_stream("Start procedures prepared in a thread")
        if self._join_event is None or not isinstance(self._join_event, Event):
            self.error_stream(f"Start procedures cannot be launched without "
                              f"joiner event")
            return
        if self._join_event.is_set():
            self.error_stream(f"Start procedures called but joiner event "
                              f"already set")
            return
        try:
            self.info_stream("Initializing FPGA registers")
            fpga_initialization_procedure(self)
        except RuntimeError as e:
            self.error_stream(f"Start procedures incomplete due to exception "
                              f"in fpga initialization:\n{e}")
            self._change_state_status(state=tango.DevState.ON,
                                      status_line="Start procedures failed",
                                      clean_important_lines=True)
        # Place to set other start procedures not related with
        #  the fpga initialization. In its own try/except.
        self._change_state_status(state=tango.DevState.RUNNING,
                                  status_line="Start procedures completed",
                                  clean_important_lines=True)
        self.debug_stream("Start procedure completed")

    def _internal_procedures(self):
        """
Target method of the monitor thread

:return:
        """
        if self._join_event is None or not isinstance(self._join_event, Event):
            self.error_stream(f"internal procedures cannot be launched without "
                              f"joiner event")
            return
        if self._internal_polling is None or \
                not isinstance(self._internal_polling, float):
            self.error_stream(f"internal procedures cannot be launched without "
                              f"polling time")
            return
        if self._internal_polling <= 0:
            self.error_stream(f"internal procedure cannot be launched without "
                              f"a positive polling time")
            return
        while not self._join_event.is_set():
            t_0 = datetime.now()
            if len(self._attributes_dict) > 0:
                hw_events, _ = self._read_all_hw_attributes()
                calculated_events, _ = self._refresh_calculated_attributes()
                events_triggered = hw_events+calculated_events
                self.statistics.events_emitted = events_triggered
            else:
                self.debug_stream("internal procedure has nothing to do yet")
                sleep(self._internal_polling)
                continue
            t_delta = datetime.now()-t_0
            self.statistics.internal_procedure_times = t_delta.total_seconds()
            if t_delta.total_seconds() > self._internal_polling:
                self.warn_stream(f"internal procedure took {t_delta}. "
                                 f"More than the limit of "
                                 f"{self._internal_polling}")
            else:
                # self.debug_stream(f"internal procedure completed with in "
                #                   f"{t_delta}")
                t_delta = datetime.now()-t_0
                sleep(self._internal_polling-t_delta.total_seconds())
        self.info_stream(f"Join event set, exiting the internal procedure "
                         f"thread")

    def _read_all_hw_attributes(self):
        """
Do a read on all the registers used by the attributes as close as possible in
time. Then store the newer values (after the formula application for the ones
that have one) and trigger all the necessary tango events.


as well as the internal attributes that may have change their
values due to this new set from the fpga

:return: pair of the number of events triggered and the number of attributes
         processed that hasn't need this emission.
        """
        t_0 = datetime.now()
        registers_to_read = [
            attribute_obj.address
            for attribute_obj in self._attributes_dict.values()
            if attribute_obj.address is not None
            and attribute_obj.address != ""]
        registers, t_delta_read = self.reader.read(registers_to_read)
        self.statistics.read_registers_time = t_delta_read.total_seconds()
        events_triggered, no_change_value, t_delta_process = \
            self.interpreter.process_read_data(registers, t_0)
        self.statistics.process_registers_time = t_delta_process.total_seconds()
        # self.debug_stream(
        #     f"Processed {len(registers)} with {events_triggered} events "
        #     f"emitted and {no_change_value} without changes in "
        #     f"{t_delta_process}")
        # self.debug_stream(f"_read_all_hw_attributes() took "
        #                   f"{datetime.now()-t_0}")
        return events_triggered, no_change_value

    def _refresh_calculated_attributes(self):
        """
To be executed close the a refresh of the hardware values, there a several
calculated attributes that doesn't have a register reference but the name of
other attributes in the formula. This method review them to refresh their
calculated value and emit all the necessary tango events.

:return: pair of the number of events triggered and the number of attributes
         processed that hasn't need this emission.
        """
        internal_attributes = [
            attribute_obj
            for attribute_obj in self._attributes_dict.values()
            if attribute_obj.address is None]
        # TODO: use the list of internal_attributes to recalculate their values
        #  based on the new register values and see if there is someone that
        #  has changed to then store the newer value and fire the event.
        events_triggered, no_change_value, t_delta_process = \
            self.interpreter.process_internal_formulas(internal_attributes)
        self.statistics.internal_formulas_time = t_delta_process.total_seconds()
        return events_triggered, no_change_value

# ==============================================================================
#    DLLRFClass class definition
# ==============================================================================


def DeviceClassInheritance(ChildClass):
    for b in ChildClass.__bases__:
        for p in ('class_property_list', 'device_property_list',
                  'cmd_list', 'attr_list'):
            d = getattr(b, p, {})
            d and getattr(ChildClass, p).update(
                (k, v) for k, v in d.items()
                if k not in getattr(ChildClass, p))
    return ChildClass


@DeviceClassInheritance
class DLLRFBaseClass(tango.DeviceClass):
    #    Class Properties
    class_property_list = {}

    #    Device Properties
    device_property_list = {
        'BoardModel':
            [tango.DevString,
             "Board Model",
             ['struck']],
        'BoardId':
            [tango.DevShort,
             "Board Id number",
             [0]],
        'WriteOffset':
            [tango.DevShort,
             "distance between read and the corresponding write registers",
             [-0x200]],
    }

    #    Command definitions
    cmd_list = {
        'Exec':
            [[tango.DevString, "none"],
             [tango.DevString, "none"],
             {
                 'Display level': tango.DispLevel.EXPERT,
             }],
        'Start':
            [[tango.DevVoid, "none"],
             [tango.DevBoolean, "none"]],
        'Stop':
            [[tango.DevVoid, "none"],
             [tango.DevBoolean, "none"]],
    }

    #    Attribute definitions
    attr_list = {
        'Version_DeviceServer':
            [[tango.DevString,
              tango.SCALAR,
              tango.READ]],
        'internal_polling':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ_WRITE],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'Memorized': "true"
             }],
        'time_arrays_max_length':
            [[tango.DevShort,
              tango.SCALAR,
              tango.READ_WRITE],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'Memorized': "true"
             }],
        'internal_procedure_times':
            [[tango.DevDouble,
              tango.SPECTRUM,
              tango.READ, 1000],
             {
                 'Display level': tango.DispLevel.EXPERT,
             }],
        'internal_procedure_times_min':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'internal_procedure_times_mean':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'internal_procedure_times_std':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'internal_procedure_times_max':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'read_registers_time':
            [[tango.DevDouble,
              tango.SPECTRUM,
              tango.READ, 1000],
             {
                 'Display level': tango.DispLevel.EXPERT,
             }],
        'read_registers_time_min':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'read_registers_time_mean':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'read_registers_time_std':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'read_registers_time_max':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'process_registers_time':
            [[tango.DevDouble,
              tango.SPECTRUM,
              tango.READ, 1000],
             {
                 'Display level': tango.DispLevel.EXPERT,
             }],
        'process_registers_time_min':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'process_registers_time_mean':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'process_registers_time_std':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'process_registers_time_max':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'internal_formulas_time':
            [[tango.DevDouble,
              tango.SPECTRUM,
              tango.READ, 1000],
             {
                 'Display level': tango.DispLevel.EXPERT,
             }],
        'internal_formulas_time_min':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'internal_formulas_time_mean':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'internal_formulas_time_std':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'internal_formulas_time_max':
            [[tango.DevDouble,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'events_emitted':
            [[tango.DevShort,
              tango.SPECTRUM,
              tango.READ, 1000],
             {
                 'Display level': tango.DispLevel.EXPERT,
             }],
        'events_emitted_min':
            [[tango.DevShort,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'events_emitted_mean':
            [[tango.DevShort,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'events_emitted_std':
            [[tango.DevShort,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'events_emitted_max':
            [[tango.DevShort,
              tango.SCALAR,
              tango.READ],
             {
                 'Display level': tango.DispLevel.EXPERT,
                 'format': "%6.3f",
             }],
        'start_procedure_output':
            [[tango.DevString,
              tango.SPECTRUM,
              tango.READ, 1000],
             {
                 'Display level': tango.DispLevel.EXPERT,
             }],
    }
